<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LO21: Automate2D Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LO21
   &#160;<span id="projectnumber">0.1</span>
   </div>
   <div id="projectbrief">automates</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="class_automate2_d-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Automate2D Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Objet qui herite de <a class="el" href="class_automate.html" title="Objet mere. ">Automate</a> Objet mere de <a class="el" href="class_automate_j_d_v.html" title="Objet qui herite de Automate2D Jeu de la vie. ">AutomateJDV</a>.  
 <a href="class_automate2_d.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="automate_8h_source.html">automate.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Automate2D:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_automate2_d.png" usemap="#Automate2D_map" alt=""/>
  <map id="Automate2D_map" name="Automate2D_map">
<area href="class_automate.html" title="Objet mere. " alt="Automate" shape="rect" coords="49,0,138,24"/>
<area href="class_automate_f_d_f.html" title="Objet qui herite de Automate2D Automate Feu de Foret : automate 2D avec 4 etats. " alt="AutomateFDF" shape="rect" coords="0,112,89,136"/>
<area href="class_automate_j_d_v.html" title="Objet qui herite de Automate2D Jeu de la vie. " alt="AutomateJDV" shape="rect" coords="99,112,188,136"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a17e604ff71ed3a3a1f806540ac73d1bd"><td class="memItemLeft" align="right" valign="top">virtual unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_automate2_d.html#a17e604ff71ed3a3a1f806540ac73d1bd">voisinage</a> (const <a class="el" href="class_etat2_d.html">Etat2D</a> &amp;etat, unsigned int i, unsigned int j) const =0</td></tr>
<tr class="memdesc:a17e604ff71ed3a3a1f806540ac73d1bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Methode abstraite pour calculer le nombre de voisin d'une cellule.  <a href="#a17e604ff71ed3a3a1f806540ac73d1bd">More...</a><br /></td></tr>
<tr class="separator:a17e604ff71ed3a3a1f806540ac73d1bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a81598b6b7e237b3a99dc9602136959"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_automate2_d.html#a5a81598b6b7e237b3a99dc9602136959">appliquerTransition</a> (const <a class="el" href="class_etat2_d.html">Etat2D</a> &amp;dep, <a class="el" href="class_etat2_d.html">Etat2D</a> &amp;dest) const =0</td></tr>
<tr class="memdesc:a5a81598b6b7e237b3a99dc9602136959"><td class="mdescLeft">&#160;</td><td class="mdescRight">La methode abstraite permet d'appliquer la regle d'evolution sur un etat designe par etatDep pour obtenir un etat qui sera designe par etatDest.  <a href="#a5a81598b6b7e237b3a99dc9602136959">More...</a><br /></td></tr>
<tr class="separator:a5a81598b6b7e237b3a99dc9602136959"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_automate"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_automate')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_automate.html">Automate</a></td></tr>
<tr class="memitem:a026ba0647d0eb182c12386efff97b88d inherit pub_methods_class_automate"><td class="memItemLeft" align="right" valign="top"><a id="a026ba0647d0eb182c12386efff97b88d"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_automate.html#a026ba0647d0eb182c12386efff97b88d">getDimension</a> () const</td></tr>
<tr class="memdesc:a026ba0647d0eb182c12386efff97b88d inherit pub_methods_class_automate"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accesseur a l'attribut dimension. <br /></td></tr>
<tr class="separator:a026ba0647d0eb182c12386efff97b88d inherit pub_methods_class_automate"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a320e22b0160179a1dabe598ccfa5afbe"><td class="memItemLeft" align="right" valign="top"><a id="a320e22b0160179a1dabe598ccfa5afbe"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_automate2_d.html#a320e22b0160179a1dabe598ccfa5afbe">Automate2D</a> ()</td></tr>
<tr class="memdesc:a320e22b0160179a1dabe598ccfa5afbe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructeur initialisant la dimension a 2. <br /></td></tr>
<tr class="separator:a320e22b0160179a1dabe598ccfa5afbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_class_automate"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_class_automate')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="class_automate.html">Automate</a></td></tr>
<tr class="memitem:a1aa780fbd484b956a13ff5d2a53f3eca inherit pro_methods_class_automate"><td class="memItemLeft" align="right" valign="top"><a id="a1aa780fbd484b956a13ff5d2a53f3eca"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_automate.html#a1aa780fbd484b956a13ff5d2a53f3eca">Automate</a> (unsigned int dim)</td></tr>
<tr class="memdesc:a1aa780fbd484b956a13ff5d2a53f3eca inherit pro_methods_class_automate"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructeur initialisant un <a class="el" href="class_automate.html" title="Objet mere. ">Automate</a> avec une dimension. <br /></td></tr>
<tr class="separator:a1aa780fbd484b956a13ff5d2a53f3eca inherit pro_methods_class_automate"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Objet qui herite de <a class="el" href="class_automate.html" title="Objet mere. ">Automate</a> Objet mere de <a class="el" href="class_automate_j_d_v.html" title="Objet qui herite de Automate2D Jeu de la vie. ">AutomateJDV</a>. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a5a81598b6b7e237b3a99dc9602136959"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5a81598b6b7e237b3a99dc9602136959">&#9670;&nbsp;</a></span>appliquerTransition()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Automate2D::appliquerTransition </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_etat2_d.html">Etat2D</a> &amp;&#160;</td>
          <td class="paramname"><em>etatDep</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_etat2_d.html">Etat2D</a> &amp;&#160;</td>
          <td class="paramname"><em>etatDest</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>La methode abstraite permet d'appliquer la regle d'evolution sur un etat designe par etatDep pour obtenir un etat qui sera designe par etatDest. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">etatDep</td><td>pour l'etat de depart sur lequel on va appliquer la transition </td></tr>
    <tr><td class="paramname">etatDest</td><td>l'etat qu'on obtient apres transition </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="class_automate_f_d_f.html#adbefaeaec50f7bce9f2dc4657d6037f2">AutomateFDF</a>, and <a class="el" href="class_automate_j_d_v.html#af1577c93a2ec3ba1d9fe1197d57299e0">AutomateJDV</a>.</p>

</div>
</div>
<a id="a17e604ff71ed3a3a1f806540ac73d1bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a17e604ff71ed3a3a1f806540ac73d1bd">&#9670;&nbsp;</a></span>voisinage()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int Automate2D::voisinage </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_etat2_d.html">Etat2D</a> &amp;&#160;</td>
          <td class="paramname"><em>etat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>j</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Methode abstraite pour calculer le nombre de voisin d'une cellule. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">etat</td><td><a class="el" href="class_etat.html" title="Classe mere Etat dont les classes filles sont Etat1D et Etat2D Le code a ete factorisee de telle sort...">Etat</a> de la cellule dont on veut connaitre son voisinage </td></tr>
    <tr><td class="paramname">i</td><td>indice de la ligne de la cellule consideree </td></tr>
    <tr><td class="paramname">j</td><td>indice de la colonne de la cellule consideree </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Retourne le nombre de voisins </dd></dl>

<p>Implemented in <a class="el" href="class_automate_f_d_f.html#a980845e4a01ee6738c1548327d32574b">AutomateFDF</a>, and <a class="el" href="class_automate_j_d_v.html#a1498bcb64efb8c2eca9ba8ed132ec577">AutomateJDV</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="automate_8h_source.html">automate.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
